package com.mocn.framework;

import java.util.Hashtable;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Paint;

/**
 * ,Ӿöƾ飬һУ鶯
 * 
 * @author Administrator
 * 
 */
public class Sprite extends Layer {
	public int frameIdx;// ǰ֡±
	public int currentFrame = 0;// ǰ֡
	public Hashtable<String, SpriteAction> actions;// 
	public SpriteAction currentAction;// ǰ

	public Sprite(Bitmap bitmap, int w, int h, boolean autoAdd) {
		super(bitmap, w, h, autoAdd);
		actions = new Hashtable<String, Sprite.SpriteAction>();// Hashtable涯
	}

	/**
	 * öķ
	 * 
	 * @param actionName
	 */
	public void setAction(String actionName) {
		currentAction = actions.get(actionName);// Ӷеõö
	}

	/**
	 * ƾķ
	 */
	@Override
	public void drawSelf(Canvas canvas, Paint paint) {
		if (currentAction != null) {
			currentFrame = currentAction.frames[frameIdx];// ȡǰҪ֡
		}
		// ȡͼƬҪ֡
		src.left = currentFrame * w;// ˿ȣǰ֡֡Ŀ
		src.top = 0;// ϶˸߶ȣ0
		src.right = src.left + w;// Ҷ˿ȣ˿ȼ֡Ŀ
		src.bottom = h;// ¶˸߶Ϊ֡ĸ߶

		// ڽϣȡĵ
		dst.left = (int) x - w / 2;
		dst.top = (int) y - h / 2;
		dst.right = dst.left + w;
		dst.bottom = dst.top + h;

		canvas.drawBitmap(bitmap, src, dst, paint);// Ƶǰ֡
		if (currentAction != null) {
			currentAction.nextFrame();// һ֡
		}
	}

	/**
	 * һϵķ
	 * 
	 * @param name
	 * @param frames
	 * @param frameTime
	 */
	public void addAction(String name, int[] frames, int[] frameTime) {
		SpriteAction sp = new SpriteAction();// SpiteActionĶ
		sp.frames = frames;// ǰ֡±ʾ
		sp.frameTime = frameTime;// ÿһ֡лʱ
		actions.put(name, sp);// Ϊ"name"ĶϣֵΪspĶϷŽacitons
	}

	/**
	 * ƶ
	 * 
	 * @param dx
	 * @param dy
	 */
	public void move(int dx, int dy) {
		this.x += dx;
		this.y += dy;
	}

	// 鶯
	class SpriteAction {
		public int[] frames;// ö֡
		public int[] frameTime;// ֡ÿһ֡лӦʱ
		private long updateTime;// ¼ϴʧЧʱ

		/**
		 * лһ֡ķ
		 */
		public void nextFrame() {
			if (System.currentTimeMillis() > updateTime) {
				frameIdx++;// ֡±
				frameIdx %= frames.length;
				updateTime = System.currentTimeMillis() + frameTime[frameIdx];// лһ֡Ҫʱ
			}
		}
	}
}
